
package de.ivu.elect.presentation.niederschrift;

import javax.inject.Inject;
import javax.inject.Named;

import de.ivu.elect.business.niederschrift.boundary.NiederschriftConversationSelect;
import de.ivu.elect.business.niederschrift.boundary.NiederschriftFormatter;
import de.ivu.elect.business.niederschrift.entity.Niederschrift;
import de.ivu.elect.business.niederschrift.entity.NiederschriftStatusAenderung;
import de.ivu.elect.business.niederschrift.entity.NiederschriftStatusAenderungConstants;
import de.ivu.elect.jee.faces.PreConditionCheck;
import de.ivu.elect.jee.presentation.dynamicform.FormBuilder;
import de.ivu.elect.presentation.hilfe.OnlineHilfeId;
import de.ivu.elect.presentation.niederschrift.form.NiederschriftStatusAenderungSearchFormBuilder;
import de.ivu.elect.presentation.security.AbstractGebietSecurityFilter;

@OnlineHilfeId("722")
@Named(AbstractNiederschriftStatusAenderungSearchView.COMPONENT_NAME)
public class NiederschriftStatusAenderungSearchView extends AbstractNiederschriftStatusAenderungSearchView {

  private static final long serialVersionUID = 1L;

  @Inject
  private transient NiederschriftConversationSelect niederschriftConversationSelect;

  @Inject
  private transient NiederschriftStatusAenderungSearchFormBuilder niederschriftStatusAenderungSearchFormBuilder;

  public NiederschriftStatusAenderungSearchView() {
    super();
  }

  @PreConditionCheck
  public String checkPreCondition() {
    if (isNiederschriftSelected()) {
      return null;
    }

    return getParentViewId();
  }

  private String getParentViewId() {
    return NiederschriftSearchView.VIEW_ID;
  }

  @Override
  protected AbstractGebietSecurityFilter<NiederschriftStatusAenderung> getGebietSecurityFilter() {
    return AbstractGebietSecurityFilter.createEntityMitGebietSecurityFilter(getEinsehenGebietSecurity());
  }

  public String getPageTitle() {
    return getMessage("entity.search.page.title", getMessage(NiederschriftStatusAenderungConstants.MESSAGE_KEY_ENTITY_MEHRZAHL));
  }

  public String getPageHeader() {
    return getMessage("entity.search.page.header", getMessage(NiederschriftStatusAenderungConstants.MESSAGE_KEY_ENTITY_MEHRZAHL));
  }

  @Override
  public boolean isOptionMenuRendered() {
    return false;
  }

  /**
   * @deprecated To be removed...
   * @see NiederschriftStatusAenderungSearchView#initSearchParametersByContext
   */
  @Deprecated
  @Override
  public void presetSearchParameters() {
    // To be removed...
  }

  @Override
  protected void initSearchParametersByContext() {
    super.initSearchParametersByContext();

    getSearchParameters().setNiederschrift(getSelectedNiederschrift());
  }

  @Override
  public String getSearchParametersHeader() {
    return getNiederschriftFormatter().formatAnzeigeNiederschrift(getSelectedNiederschrift(), getMessages());
  }

  @Override
  public void addProperties(FormBuilder formBuilder) {
    niederschriftStatusAenderungSearchFormBuilder.addProperties(formBuilder, getSelectedNiederschrift());
  }

  @Override
  public boolean isBtnSearchRendered() {
    return false;
  }

  @Override
  public boolean isBtnResetRendered() {
    return false;
  }

  @Override
  public boolean isBtnGoBackRendered() {
    return true;
  }

  private boolean isNiederschriftSelected() {
    return niederschriftConversationSelect.isSelected();
  }

  private Niederschrift getSelectedNiederschrift() {
    return niederschriftConversationSelect.getEntity();
  }

  private NiederschriftFormatter getNiederschriftFormatter() {
    return niederschriftStatusAenderungSearchFormBuilder.getNiederschriftFormatter();
  }
}
